# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawAccountingClient, RawAccountingClient
from .resources.account_details.client import AccountDetailsClient, AsyncAccountDetailsClient
from .resources.account_token.client import AccountTokenClient, AsyncAccountTokenClient
from .resources.accounting_periods.client import AccountingPeriodsClient, AsyncAccountingPeriodsClient
from .resources.accounts.client import AccountsClient, AsyncAccountsClient
from .resources.addresses.client import AddressesClient, AsyncAddressesClient
from .resources.async_passthrough.client import AsyncAsyncPassthroughClient
from .resources.async_passthrough.client import (
    AsyncPassthroughClient as resources_accounting_resources_async_passthrough_client_AsyncPassthroughClient,
)
from .resources.async_tasks.client import AsyncAsyncTasksClient, AsyncTasksClient
from .resources.attachments.client import AsyncAttachmentsClient, AttachmentsClient
from .resources.audit_trail.client import AsyncAuditTrailClient, AuditTrailClient
from .resources.available_actions.client import AsyncAvailableActionsClient, AvailableActionsClient
from .resources.balance_sheets.client import AsyncBalanceSheetsClient, BalanceSheetsClient
from .resources.bank_feed_accounts.client import AsyncBankFeedAccountsClient, BankFeedAccountsClient
from .resources.bank_feed_transactions.client import AsyncBankFeedTransactionsClient, BankFeedTransactionsClient
from .resources.cash_flow_statements.client import AsyncCashFlowStatementsClient, CashFlowStatementsClient
from .resources.company_info.client import AsyncCompanyInfoClient, CompanyInfoClient
from .resources.contacts.client import AsyncContactsClient, ContactsClient
from .resources.credit_notes.client import AsyncCreditNotesClient, CreditNotesClient
from .resources.delete_account.client import AsyncDeleteAccountClient, DeleteAccountClient
from .resources.employees.client import AsyncEmployeesClient, EmployeesClient
from .resources.expense_reports.client import AsyncExpenseReportsClient, ExpenseReportsClient
from .resources.expenses.client import AsyncExpensesClient, ExpensesClient
from .resources.field_mapping.client import AsyncFieldMappingClient, FieldMappingClient
from .resources.force_resync.client import AsyncForceResyncClient, ForceResyncClient
from .resources.general_ledger_transactions.client import (
    AsyncGeneralLedgerTransactionsClient,
    GeneralLedgerTransactionsClient,
)
from .resources.generate_key.client import AsyncGenerateKeyClient, GenerateKeyClient
from .resources.income_statements.client import AsyncIncomeStatementsClient, IncomeStatementsClient
from .resources.invoices.client import AsyncInvoicesClient, InvoicesClient
from .resources.issues.client import AsyncIssuesClient, IssuesClient
from .resources.items.client import AsyncItemsClient, ItemsClient
from .resources.journal_entries.client import AsyncJournalEntriesClient, JournalEntriesClient
from .resources.link_token.client import AsyncLinkTokenClient, LinkTokenClient
from .resources.linked_accounts.client import AsyncLinkedAccountsClient, LinkedAccountsClient
from .resources.passthrough.client import (
    AsyncPassthroughClient as resources_accounting_resources_passthrough_client_AsyncPassthroughClient,
)
from .resources.passthrough.client import PassthroughClient
from .resources.payment_methods.client import AsyncPaymentMethodsClient, PaymentMethodsClient
from .resources.payment_terms.client import AsyncPaymentTermsClient, PaymentTermsClient
from .resources.payments.client import AsyncPaymentsClient, PaymentsClient
from .resources.phone_numbers.client import AsyncPhoneNumbersClient, PhoneNumbersClient
from .resources.projects.client import AsyncProjectsClient, ProjectsClient
from .resources.purchase_orders.client import AsyncPurchaseOrdersClient, PurchaseOrdersClient
from .resources.regenerate_key.client import AsyncRegenerateKeyClient, RegenerateKeyClient
from .resources.scopes.client import AsyncScopesClient, ScopesClient
from .resources.sync_status.client import AsyncSyncStatusClient, SyncStatusClient
from .resources.tax_rates.client import AsyncTaxRatesClient, TaxRatesClient
from .resources.tracking_categories.client import AsyncTrackingCategoriesClient, TrackingCategoriesClient
from .resources.transactions.client import AsyncTransactionsClient, TransactionsClient
from .resources.vendor_credits.client import AsyncVendorCreditsClient, VendorCreditsClient
from .resources.webhook_receivers.client import AsyncWebhookReceiversClient, WebhookReceiversClient


class AccountingClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawAccountingClient(client_wrapper=client_wrapper)
        self.account_details = AccountDetailsClient(client_wrapper=client_wrapper)

        self.account_token = AccountTokenClient(client_wrapper=client_wrapper)

        self.accounting_periods = AccountingPeriodsClient(client_wrapper=client_wrapper)

        self.accounts = AccountsClient(client_wrapper=client_wrapper)

        self.addresses = AddressesClient(client_wrapper=client_wrapper)

        self.async_passthrough = resources_accounting_resources_async_passthrough_client_AsyncPassthroughClient(
            client_wrapper=client_wrapper
        )

        self.async_tasks = AsyncTasksClient(client_wrapper=client_wrapper)

        self.attachments = AttachmentsClient(client_wrapper=client_wrapper)

        self.audit_trail = AuditTrailClient(client_wrapper=client_wrapper)

        self.available_actions = AvailableActionsClient(client_wrapper=client_wrapper)

        self.balance_sheets = BalanceSheetsClient(client_wrapper=client_wrapper)

        self.bank_feed_accounts = BankFeedAccountsClient(client_wrapper=client_wrapper)

        self.bank_feed_transactions = BankFeedTransactionsClient(client_wrapper=client_wrapper)

        self.cash_flow_statements = CashFlowStatementsClient(client_wrapper=client_wrapper)

        self.company_info = CompanyInfoClient(client_wrapper=client_wrapper)

        self.contacts = ContactsClient(client_wrapper=client_wrapper)

        self.credit_notes = CreditNotesClient(client_wrapper=client_wrapper)

        self.scopes = ScopesClient(client_wrapper=client_wrapper)

        self.delete_account = DeleteAccountClient(client_wrapper=client_wrapper)

        self.employees = EmployeesClient(client_wrapper=client_wrapper)

        self.expense_reports = ExpenseReportsClient(client_wrapper=client_wrapper)

        self.expenses = ExpensesClient(client_wrapper=client_wrapper)

        self.field_mapping = FieldMappingClient(client_wrapper=client_wrapper)

        self.general_ledger_transactions = GeneralLedgerTransactionsClient(client_wrapper=client_wrapper)

        self.generate_key = GenerateKeyClient(client_wrapper=client_wrapper)

        self.income_statements = IncomeStatementsClient(client_wrapper=client_wrapper)

        self.invoices = InvoicesClient(client_wrapper=client_wrapper)

        self.issues = IssuesClient(client_wrapper=client_wrapper)

        self.items = ItemsClient(client_wrapper=client_wrapper)

        self.journal_entries = JournalEntriesClient(client_wrapper=client_wrapper)

        self.link_token = LinkTokenClient(client_wrapper=client_wrapper)

        self.linked_accounts = LinkedAccountsClient(client_wrapper=client_wrapper)

        self.passthrough = PassthroughClient(client_wrapper=client_wrapper)

        self.payment_methods = PaymentMethodsClient(client_wrapper=client_wrapper)

        self.payment_terms = PaymentTermsClient(client_wrapper=client_wrapper)

        self.payments = PaymentsClient(client_wrapper=client_wrapper)

        self.phone_numbers = PhoneNumbersClient(client_wrapper=client_wrapper)

        self.projects = ProjectsClient(client_wrapper=client_wrapper)

        self.purchase_orders = PurchaseOrdersClient(client_wrapper=client_wrapper)

        self.regenerate_key = RegenerateKeyClient(client_wrapper=client_wrapper)

        self.sync_status = SyncStatusClient(client_wrapper=client_wrapper)

        self.force_resync = ForceResyncClient(client_wrapper=client_wrapper)

        self.tax_rates = TaxRatesClient(client_wrapper=client_wrapper)

        self.tracking_categories = TrackingCategoriesClient(client_wrapper=client_wrapper)

        self.transactions = TransactionsClient(client_wrapper=client_wrapper)

        self.vendor_credits = VendorCreditsClient(client_wrapper=client_wrapper)

        self.webhook_receivers = WebhookReceiversClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawAccountingClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawAccountingClient
        """
        return self._raw_client


class AsyncAccountingClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawAccountingClient(client_wrapper=client_wrapper)
        self.account_details = AsyncAccountDetailsClient(client_wrapper=client_wrapper)

        self.account_token = AsyncAccountTokenClient(client_wrapper=client_wrapper)

        self.accounting_periods = AsyncAccountingPeriodsClient(client_wrapper=client_wrapper)

        self.accounts = AsyncAccountsClient(client_wrapper=client_wrapper)

        self.addresses = AsyncAddressesClient(client_wrapper=client_wrapper)

        self.async_passthrough = AsyncAsyncPassthroughClient(client_wrapper=client_wrapper)

        self.async_tasks = AsyncAsyncTasksClient(client_wrapper=client_wrapper)

        self.attachments = AsyncAttachmentsClient(client_wrapper=client_wrapper)

        self.audit_trail = AsyncAuditTrailClient(client_wrapper=client_wrapper)

        self.available_actions = AsyncAvailableActionsClient(client_wrapper=client_wrapper)

        self.balance_sheets = AsyncBalanceSheetsClient(client_wrapper=client_wrapper)

        self.bank_feed_accounts = AsyncBankFeedAccountsClient(client_wrapper=client_wrapper)

        self.bank_feed_transactions = AsyncBankFeedTransactionsClient(client_wrapper=client_wrapper)

        self.cash_flow_statements = AsyncCashFlowStatementsClient(client_wrapper=client_wrapper)

        self.company_info = AsyncCompanyInfoClient(client_wrapper=client_wrapper)

        self.contacts = AsyncContactsClient(client_wrapper=client_wrapper)

        self.credit_notes = AsyncCreditNotesClient(client_wrapper=client_wrapper)

        self.scopes = AsyncScopesClient(client_wrapper=client_wrapper)

        self.delete_account = AsyncDeleteAccountClient(client_wrapper=client_wrapper)

        self.employees = AsyncEmployeesClient(client_wrapper=client_wrapper)

        self.expense_reports = AsyncExpenseReportsClient(client_wrapper=client_wrapper)

        self.expenses = AsyncExpensesClient(client_wrapper=client_wrapper)

        self.field_mapping = AsyncFieldMappingClient(client_wrapper=client_wrapper)

        self.general_ledger_transactions = AsyncGeneralLedgerTransactionsClient(client_wrapper=client_wrapper)

        self.generate_key = AsyncGenerateKeyClient(client_wrapper=client_wrapper)

        self.income_statements = AsyncIncomeStatementsClient(client_wrapper=client_wrapper)

        self.invoices = AsyncInvoicesClient(client_wrapper=client_wrapper)

        self.issues = AsyncIssuesClient(client_wrapper=client_wrapper)

        self.items = AsyncItemsClient(client_wrapper=client_wrapper)

        self.journal_entries = AsyncJournalEntriesClient(client_wrapper=client_wrapper)

        self.link_token = AsyncLinkTokenClient(client_wrapper=client_wrapper)

        self.linked_accounts = AsyncLinkedAccountsClient(client_wrapper=client_wrapper)

        self.passthrough = resources_accounting_resources_passthrough_client_AsyncPassthroughClient(
            client_wrapper=client_wrapper
        )

        self.payment_methods = AsyncPaymentMethodsClient(client_wrapper=client_wrapper)

        self.payment_terms = AsyncPaymentTermsClient(client_wrapper=client_wrapper)

        self.payments = AsyncPaymentsClient(client_wrapper=client_wrapper)

        self.phone_numbers = AsyncPhoneNumbersClient(client_wrapper=client_wrapper)

        self.projects = AsyncProjectsClient(client_wrapper=client_wrapper)

        self.purchase_orders = AsyncPurchaseOrdersClient(client_wrapper=client_wrapper)

        self.regenerate_key = AsyncRegenerateKeyClient(client_wrapper=client_wrapper)

        self.sync_status = AsyncSyncStatusClient(client_wrapper=client_wrapper)

        self.force_resync = AsyncForceResyncClient(client_wrapper=client_wrapper)

        self.tax_rates = AsyncTaxRatesClient(client_wrapper=client_wrapper)

        self.tracking_categories = AsyncTrackingCategoriesClient(client_wrapper=client_wrapper)

        self.transactions = AsyncTransactionsClient(client_wrapper=client_wrapper)

        self.vendor_credits = AsyncVendorCreditsClient(client_wrapper=client_wrapper)

        self.webhook_receivers = AsyncWebhookReceiversClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawAccountingClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawAccountingClient
        """
        return self._raw_client
