# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ....core.pydantic_utilities import IS_PYDANTIC_V2
from ....core.unchecked_base_model import UncheckedBaseModel


class EmailAddress(UncheckedBaseModel):
    """
    # The EmailAddress Object
    ### Description
    The `EmailAddress` object is used to represent an entity's email address.
    ### Usage Example
    Fetch from the `GET Contact` endpoint and view their email addresses.
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The datetime that this object was created by Merge.
    """

    modified_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The datetime that this object was modified by Merge.
    """

    email_address: typing.Optional[str] = pydantic.Field(default=None)
    """
    The email address.
    """

    email_address_type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The email address's type.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
